cc.Class({
    extends: cc.Component,

    properties: {
        label: {
            default: null,
            type: cc.Label
        },
        // defaults, set visually when attaching this script to the Canvas
        text: 'Hello, World!',
        player: {
            default: null,
            type: cc.Node,
        },
        weapon: {
            default: null,
            type: cc.Node,
        },
        playerMoveTo: 't',
        speed: 200,
    },

    // use this for initialization
    onLoad: function () {
        cc.director.getPhysicsManager().enabled = true;
        cc.director.getPhysicsManager().debugDrawFlags = cc.PhysicsManager.DrawBits.e_aabbBit |
            cc.PhysicsManager.DrawBits.e_pairBit |
            cc.PhysicsManager.DrawBits.e_centerOfMassBit |
            cc.PhysicsManager.DrawBits.e_jointBit |
            cc.PhysicsManager.DrawBits.e_shapeBit
            ;
        this.label.string = this.text;
        this.onMonitor();
    },



    onMonitor() {
        cc.systemEvent.on(cc.SystemEvent.EventType.KEY_DOWN, this.onKeyDown, this);
        // 当有键盘松开
        cc.systemEvent.on(cc.SystemEvent.EventType.KEY_UP, this.onKeyUp, this);
    },

    onKeyDown(event) {
        switch (event.keyCode) {
            case cc.macro.KEY.w:
                this.playerMoveTo = 'w';
                break;
            case cc.macro.KEY.s:
                this.playerMoveTo = 's';
                break;
            case cc.macro.KEY.a:
                this.playerMoveTo = 'a';
                break;
            case cc.macro.KEY.d:
                this.playerMoveTo = 'd';
                break;
        }
    },

    onKeyUp(event) {
        this.playerMoveTo = 't'
        let body = this.player.getComponent(cc.RigidBody);
        body.linearVelocity = cc.v2(0, 0);
        console.log('松开')
    },

    //按钮 可忽视
    weaponAnimBt(event) {
        let body = this.weapon.getComponent(cc.RigidBody);
        this.weapon.enabled = true;
        console.log(this.weapon.angle)
        if (this.weapon.angle == -390) {
            //right
            this.weapon.angle = -390;
            let rotateDown = cc.rotateTo(0.2, 110);
            let delay = cc.delayTime(0.05);
            let rotateUp = cc.rotateTo(0.1, 30);
            let callf = cc.callFunc(() => {
                this.weapon.angle = -390;
            })
            this.weapon.runAction(cc.sequence(rotateDown, delay, rotateUp, callf));
        } else if (this.weapon.angle == -330) {
            //left
            this.weapon.angle = -330;
            let rotateDown = cc.rotateTo(0.2, -110);
            let delay = cc.delayTime(0.05);
            let rotateUp = cc.rotateTo(0.1, -30);
            let callf = cc.callFunc(() => {
                this.weapon.angle = -330;
            })
            this.weapon.runAction(cc.sequence(rotateDown, delay, rotateUp, callf));
        }


    },

    // called every frame
    update: function (dt) {
        let body = this.player.getComponent(cc.RigidBody);
        if (this.playerMoveTo == 't') {
            return;
        }
        if (this.playerMoveTo == 'w') {
            body.linearVelocity = cc.v2(0, this.speed);
        }
        if (this.playerMoveTo == 's') {
            body.linearVelocity = cc.v2(0, -this.speed);
        }
        if (this.playerMoveTo == 'a') {
            this.weapon.angle = -330;
            body.linearVelocity = cc.v2(-this.speed, 0);
        }
        if (this.playerMoveTo == 'd') {
            this.weapon.angle = -390;
            body.linearVelocity = cc.v2(this.speed, 0);
        }
    },
});
